#!/bin/bash
export HB_INS=/apps/harbour
SYSTEM_LIBS="-lm -lncurses"
HARBOUR_LIBS="-lhbdebug -lhbvm -lhbrtl -lgtcgi -lgtcrs -lhblang -lhbrdd -lhbrtl -lhbvm -lhbmacro -lhbpp -lrddleto -lrddntx -lrddcdx -lrddfpt -lhbsix -lhbcommon -lhbcpage -lhbct"
HWGUI_LIBS="-lhwgui -lprocmisc -lhbxml"
HWGUI_INC=$HB_INS/hwgui_216c/include
HWGUI_LIB=$HB_INS/hwgui_216c/gtk/lib

$HB_INS/bin/harbour general -n -i$HB_INS/include -i$HWGUI_INC -w2 -d__LINUX__ -dRDD_CDX >bldh.log
$HB_INS/bin/harbour procflt -n -i$HB_INS/include -i$HWGUI_INC -w2 -d__LINUX__ >>bldh.log
$HB_INS/bin/harbour hprocpsw -n -i$HB_INS/include -i$HWGUI_INC -w2 -d__LINUX__ >>bldh.log
$HB_INS/bin/harbour procs3 -n -i$HB_INS/include -i$HWGUI_INC -w2 -d__LINUX__ >>bldh.log
gcc general.c procflt.c hprocpsw.c procs3.c -ogenerall -I $HB_INS/include -L $HB_INS/lib -L $HWGUI_LIB $SYSTEM_LIBS -Wl,--start-group $HWGUI_LIBS $HARBOUR_LIBS -Wl,--end-group  `pkg-config gtk+-2.0 --libs` >bld.log 2>bld.log
rm *.c
mv ./generall ../