
#include "hbclass.ch"
#include "hwgui.ch"

FUNCTION RMONTH( nMonth, l2 )

   /*
#ifdef __LINUX__
LOCAL m1 := { "", "", "", "", "", "", ;
   "", "", "", "", "", "" }
LOCAL m2 := { "", "", "", "", "", "", ;
   "", "", "", "", "", "" }
#else
*/
LOCAL m1 := { "", "", "", "", "", "", ;
                 "", "", "", "", "", "" }
LOCAL m2 := { "", "", "", "", "", "", ;
                 "", "", "", "", "", "" }
   // #endif

   IF nMonth == Nil
      RETURN Iif( l2 == Nil .OR. !l2, m1, m2 )
   ENDIF
   IF nMonth < 1 .OR. nMonth > 12
      RETURN ""
   ENDIF
RETURN Iif( l2 == Nil .OR. !l2, m1[ nMonth ], m2[ nMonth ] )

FUNCTION PROPIS( chislo, lMoney, valut )

LOCAL str1, str2, str3, strrez := "", i, j, nlen, kolgr, kod, prbe, strupp, strlow, skop
LOCAL msnm1[ 4 ], msnm2[ 4 ], msnm3[ 4 ]
   /*
#ifdef __LINUX__
LOCAL mssot  := { "", "", "", "", "", "", "", "", "" }
LOCAL msdes  := { "", "", "", "", "", "", "", "" }
LOCAL ms1des := { "", "", "", "", "", "", "", "", "", "" }
LOCAL msed   := { "", "", "", "", "", "", "", "", "" }
LOCAL msed1  := { "", "" }
#else
*/
LOCAL mssot  := { "", "", "", "", "", "", "", "", "" }
LOCAL msdes  := { "", "", "", "", "", "", "", "" }
LOCAL ms1des := { "", "", "", "", "", "", "", "", "", "" }
LOCAL msed   := { "", "", "", "", "", "", "", "", "" }
LOCAL msed1  := { "", "" }
   // #endif
LOCAL msrod := { .T., .T., .F., .T. }

   lMoney := Iif( lMoney == Nil, .T., lMoney )
   valut  := Iif( valut == Nil, .F., valut )
   IF Valtype( chislo ) == "N"
      chislo := Ltrim( Str( chislo ) )
   ELSE
      chislo := Alltrim( chislo )
   ENDIF

   /*
#ifdef __LINUX__
   msnm1[ 1 ] = ""
   msnm1[ 2 ] = ""
   msnm1[ 3 ] = ""
   msnm1[ 4 ] = IIF( lMoney, IIF( valut, " ", "" ), "" )
   msnm2[ 1 ] = ""
   msnm2[ 2 ] = ""
   msnm2[ 3 ] = ""
   msnm2[ 4 ] = IIF( lMoney, IIF( valut, " ", "" ), "" )
   msnm3[ 1 ] = ""
   msnm3[ 2 ] = ""
   msnm3[ 3 ] = ""
   msnm3[ 4 ] = IIF( lMoney, IIF( valut, " ", "" ), "" )

   strupp := ""
   strlow := ""
#else
*/
   msnm1[ 1 ] = ""
   msnm1[ 2 ] = ""
   msnm1[ 3 ] = ""
   msnm1[ 4 ] = Iif( lMoney, Iif( valut, " ", "" ), "" )
   msnm2[ 1 ] = ""
   msnm2[ 2 ] = ""
   msnm2[ 3 ] = ""
   msnm2[ 4 ] = Iif( lMoney, Iif( valut, " ", "" ), "" )
   msnm3[ 1 ] = ""
   msnm3[ 2 ] = ""
   msnm3[ 3 ] = ""
   msnm3[ 4 ] = Iif( lMoney, Iif( valut, " ", "" ), "" )

   strupp := ""
   strlow := ""
   // #endif
   str2   := Space( 10 )
   str3   := Space( 10 )
   strrez := Space( 120 )

   nlen := At( ".", chislo ) - 1
   IF nlen < 0
      nlen := Len( chislo )
   ENDIF
   kolgr := Int( ( nlen + 2 ) / 3 )
   i     := kolgr * 3 - nlen
   str1  := Replicate( "0", i ) + chislo

   FOR j := 0 TO kolgr - 1
      prbe := .F.
      kod  := Val( Substr( str1, j * 3 + 1, 1 ) )
      IF kod <> 0
         strrez := Trim( strrez ) + " " + mssot[ kod ]
         prbe   := .T.
      ENDIF
      kod := Val( Substr( str1, j * 3 + 2, 1 ) )
      IF kod = 1
         kod    := Val( Substr( str1, j * 3 + 3, 1 ) )
         strrez := Trim( strrez ) + " " + ms1des[ kod + 1 ]
         str3   := msnm3[ 5 - kolgr + j ]
         prbe   := .T.
      ELSE
         IF kod <> 0
            strrez := Trim( strrez ) + " " + msdes[ kod - 1 ]
            prbe   := .T.
         ENDIF
         kod := Val( Substr( str1, j * 3 + 3, 1 ) )
         IF kod = 1
            str3 := msnm1[ 5 - kolgr + j ]
         ELSEIF kod > 1 .AND. kod < 5
            str3 := msnm2[ 5 - kolgr + j ]
         ELSE
            IF kod = 0 .AND. prbe = .F. .AND. j <> kolgr - 1
               str3 := " "
            ELSE
               str3 := msnm3[ 5 - kolgr + j ]
            ENDIF
         ENDIF
         IF kod != 0
            IF msrod[ 5 - kolgr + j ] .OR. kod > 2
               str2 := msed[ kod ]
            ELSE
               str2 := msed1[ kod ]
            ENDIF
            strrez := Trim( strrez ) + " " + str2
         ELSEIF nlen == 1
            /*
#ifdef __LINUX__
            strrez := TRIM( strrez ) + " "
#else */
            strrez := Trim( strrez ) + " "
            // #endif
         ENDIF
      ENDIF
      strrez := Trim( strrez ) + " " + str3
   NEXT

   IF lMoney
      kod := Val( Substr( chislo, nlen + 2, 2 ) )
      IF kod != 0
         skop := Val( Substr( chislo, nlen + 3, 1 ) )
         IF valut
            strrez := Trim( strrez ) + " " + Substr( chislo, nlen + 2, 2 ) + Iif( ( kod > 9 .AND. kod < 21 ) .OR. skop = 0 .OR. skop > 4, " ", Iif( skop = 1, " ", " " ) )
         ELSE
            strrez := Trim( strrez ) + " " + Substr( chislo, nlen + 2, 2 ) + Iif( ( kod > 9 .AND. kod < 21 ) .OR. skop = 0 .OR. skop > 4, " ", Iif( skop = 1, " ", " " ) )
         ENDIF
      ELSE
         strrez := Trim( strrez ) + "="
      ENDIF
   ENDIF
   i := At( Substr( strrez, 2, 1 ), strlow )
   IF i > 0
      strrez := Stuff( strrez, 2, 1, Substr( strupp, i, 1 ) )
   ENDIF
RETURN strrez

FUNCTION StrinDiv( stroka, partLen, partNum )

LOCAL i := 1, strtmp, pos := 1, pos1
   DO WHILE i <= partNum
      strtmp := Substr( stroka, pos, partLen )
      IF Len( strtmp ) < partLen
         pos1 := 0
      ELSE
         pos1 := Max( Max( Rat( " ", strtmp ), Rat( ",", strtmp ) ), Rat( ".", strtmp ) )
      ENDIF
      pos += Iif( pos1 = 0, partLen, pos1 )
      i ++
   ENDDO
RETURN Iif( pos1 = 0, strtmp, Left( strtmp, pos1 ) )

FUNCTION ASUM( ms1, n1, n2 )

LOCAL rezsum := 0, i
   n1 := Iif( n1 = Nil, 1, n1 )
   n2 := Iif( n2 = Nil, Len( ms1 ), n2 )
   FOR i := n1 TO n2
      rezsum += ms1[ i ]
   NEXT
RETURN rezsum

FUNCTION DC2000( d1, delimi )

   delimi := Iif( delimi = Nil, '/', delimi )
RETURN Padl( Day( d1 ), 2, "0" ) + delimi + Padl( Month( d1 ), 2, "0" ) + delimi + Str( Year( d1 ), 4 )

FUNCTION ADDMONTH( dt, n )

LOCAL mn, ye
   mn := Month( dt ) + n % 12
   ye := Year( dt ) + Int( n / 12 )
   IF mn > 12
      ye ++
      mn -= 12
   ELSEIF mn < 0
      ye --
      mn += 12
   ENDIF
RETURN Ctod( Padl( Day( dt ), 2, "0" ) + "/" + Padl( mn, 2, "0" ) + "/" + Substr( Str( ye, 4 ), 3, 2 ) )

FUNCTION ACondAdd( arr, kolItems, aItems )

LOCAL i, nIndex, lNew := .F.
   kolItems := Iif( kolItems == Nil, Len( arr ), kolItems )
   IF ( nIndex := ASCAN( arr, { | aVal | aVal[ 1 ] == aItems[ 1 ] }, 1, kolItems ) ) == 0
      IF ++ kolItems > Len( arr )
         Aadd( arr, Array( Len( aItems ) ) )
         Afill( arr[ Len( arr ) ], 0 )
      ENDIF
      arr[ kolItems, 1 ] := aItems[ 1 ]
      nIndex             := kolItems
      lNew               := .T.
   ENDIF
   FOR i := 2 TO Len( aItems )
      IF Valtype( aItems[ i ] ) == "N"
         arr[ nIndex, i ] += aItems[ i ]
      ELSEIF lNew
         arr[ nIndex, i ] := aItems[ i ]
      ENDIF
   NEXT
RETURN nIndex

FUNCTION EXECUTE( expres )

LOCAL vartmp, poz
MEMVAR pend
PRIVATE pend := .T.
   DO WHILE pend
      poz := FIND_Z( expres )
      IF poz <> 0
         vartmp := &( Substr( expres, 1, poz - 1 ) )
         expres := Substr( expres, poz + 1 )
      ELSE
         IF .NOT. Empty( expres )
            vartmp := &expres
            EXIT
         ENDIF
      ENDIF
   ENDDO
RETURN vartmp

FUNCTION ASCAN2( arr, value, n )

   IF n == Nil 
      n := 1
   ENDIF
RETURN Ascan( arr, { | a | a[ n ] == value } )

FUNCTION ZPLOCK

   DO WHILE .NOT. Rlock()
      hwg_Msgstop( "!    !" )
   ENDDO

RETURN .T.

FUNCTION hu_Get( tsoob, tpict, txget )

LOCAL oDlg, oFont := HFont():Add( "MS Sans Serif", 0, - 13 )
LOCAL cRes := ""

   INIT DIALOG oDlg TITLE tsoob AT 0, 0 SIZE 300, 100 ;
           FONT oFont CLIPPER STYLE WS_POPUP + WS_VISIBLE + WS_CAPTION + WS_SYSMENU + WS_SIZEBOX + DS_CENTER

   @ 20, 15 GET txget SIZE 260, 26 PICTURE tpict        

   @ 20, 55 BUTTON "Ok" ID IDOK SIZE 100, 32
   @ 180, 55 BUTTON "Cancel" ID IDCANCEL SIZE 100, 32

   ACTIVATE DIALOG oDlg

   oFont:Release()
   IF oDlg:lResult
      RETURN Iif( Valtype( txget ) == "C", Trim( txget ), txget )
   ENDIF

RETURN ""

FUNCTION AsortM( arr, lDesc )

RETURN Iif( lDesc == Nil .OR. !lDesc, Asort( arr,,, { | z, y | z[ 1 ] < y[ 1 ] } ), Asort( arr,,, { | z, y | z[ 1 ] > y[ 1 ] } ) )

FUNCTION AGetEl1( arr, x1 )
   LOCAL n := Ascan( arr, {|a|a[1]==x1} )
   
RETURN Iif( n==0, Nil, arr[n,2] )

Function Nil2S( xVal )
RETURN Iif( Empty(xVal), "", xVal )

FUNCTION TRN_NUM( xNum, nDec, cRzd )
LOCAL cNum, i

   IF cRzd == Nil; cRzd := " "; ENDIF
   IF Valtype( xNum ) == "N"
      IF nDec == Nil
         xNum := Str( xNum )
      ELSE
         xNum := Str( xNum,19,nDec )
      ENDIF
   ENDIF
   xNum := Ltrim( xNum )
   IF ( i := Rat( ".",xNum ) ) == 0
      cNum := ""
      i := Len( xNum )
   ELSE
      cNum := Substr( xNum, i )
      i --
   ENDIF

   DO WHILE .T.
      i -= 3
      IF i <= 0
         cNum := Left( xNum, i+3 ) + cNum
         EXIT
      ELSE
         cNum := cRzd + Substr(xNum, i+1, 3 ) + cNum
      ENDIF
   ENDDO
RETURN cNum

CLASS HULogo INHERIT HDIALOG

   DATA oLbl
   DATA oBar
   DATA oDlg
   METHOD New( nWidth, nHeight, cTitle, cText )
   METHOD Set( cTitle, nPos, nLimit )
   METHOD Step()
   METHOD Close() INLINE( ::oDlg:Close(), ::oDlg:oFont:Release() )

ENDCLASS

METHOD New( nWidth, nHeight, cTitle, cText ) CLASS HULogo
LOCAL oFont := HFont():Add( "MS Sans Serif", 0, - 13 )

   IF cTitle == Nil 
      cTitle := ""
   ENDIF
   IF cText == Nil 
      cText := ""
   ENDIF

   INIT DIALOG ::oDlg TITLE cTitle AT 0, 0 SIZE nWidth, nHeight ;
           FONT oFont STYLE DS_CENTER + WS_POPUP + WS_VISIBLE + WS_CAPTION

   @ 05, 20 SAY ::oLbl CAPTION cText SIZE nWidth - 10, 22 STYLE SS_CENTER         
#ifndef __LINUX__
   ::oBar := HProgressBar():New( ::oDlg,, 20, nHeight - 30, nWidth - 40, 20, 10, 10 )
#endif
   ACTIVATE DIALOG ::oDlg NOMODAL

RETURN Self

METHOD Set( cTitle, nPos, nLimit ) CLASS HULogo

   IF cTitle != Nil
      ::oLbl:SetValue( cTitle )
   ENDIF
#ifndef __LINUX__
   IF nPos != Nil
      ::oBar:Set(, nPos )
   ENDIF
   IF nLimit != Nil
      ::oBar:nLimit := nLimit
   ENDIF
#endif
   RETURN Nil

METHOD Step() CLASS HULogo
#ifndef __LINUX__
   ::oBar:Step()
#endif
   RETURN Nil

#ifdef RDD_ADS
#include "ads.ch"
FUNCTION BeginTransact

   BEGIN TRANSACTION
RETURN Nil

FUNCTION CommiTransact

   COMMIT TRANSACTION
   RETURN Nil
#else
FUNCTION BeginTransact

RETURN Nil

FUNCTION CommiTransact

RETURN Nil
#endif
