/*
 *   
 *    
 *
 * Copyright 2006 Alexander S.Kresin <alex@belacy.belgorod.su>
 * www - http://kresin.belgorod.su
*/

#include "guilib.ch"

FUNCTION SPEEDFLT( expflt, stusl, stseek )
LOCAL rez := .F., iord := 0, ielem, elemf, ellen, elemzn, pos, pos_in_ielem, pos3, expind, c
LOCAL l1 := .F.

   stusl := stseek := ""
   DO WHILE !rez
      //     
      iord ++
      expind := Upper( Ordkey( iord ) )
      //     , 
      IF Empty( expind )
         EXIT
      ELSE
         DO WHILE !Empty( expind )
            //       (ielem)
            //        (elemf)
            IF ( pos := At( "+", expind ) ) != 0
               ielem := Left( expind, pos - 1 )
               pos ++
               expind := Substr( expind, pos )
            ELSE
               ielem  := expind
               expind := ""
            ENDIF
            IF ( pos_in_ielem := At( "(", ielem ) ) == 0
               elemf := ielem
            ELSE
               elemf := Substr( ielem, pos_in_ielem + 1 )
               IF ( pos := At( ",", elemf ) ) == 0
                  pos := At( ")", elemf )
               ENDIF
               IF pos != 0
                  elemf := Left( elemf, pos - 1 )
               ENDIF
            ENDIF
            ellen := Len( elemf )
            //         /
            pos := At( elemf, Upper( expflt ) )
            //   ,     "=",      ,
            //    
            IF pos > 0 .AND. Substr( expflt, pos + ellen, 1 ) == "=" .AND. ;
                       At( elemf, Upper( Substr( expflt, pos + ellen + 1 ) ) ) == 0
               rez    := .T.
               elemzn := Substr( expflt, pos + ellen + 1 )
               IF ( c := Left( elemzn, 1 ) ) == '"' .OR. c == "'"
                  IF ( pos3 := At( c, Substr( elemzn, 2 ) ) ) == 0
                     stusl := stseek := ""
                     RETURN .F.
                  ENDIF
                  elemzn := Left( elemzn, pos3 + 1 )
               ELSEIF ( pos := At( ".", elemzn ) ) != 0
                  IF Isdigit( Substr( elemzn, pos + 1 ) )
                     pos3 := At( ".", Substr( elemzn, pos + 1 ) )
                     pos  += Iif( pos3 = 0, 999, pos3 )
                  ENDIF
                  //    -   (elemzn)
                  elemzn := Left( elemzn, pos - 1 )
               ELSEIF ( pos := At( ")", elemzn ) ) != 0
                  elemzn := Left( elemzn, pos - 1 )
               ENDIF
               IF !l1
                  stusl  += Iif( Empty( stusl ), "", ".AND." ) + elemf + "=" + elemzn
                  c := Iif( pos_in_ielem == 0, &elemzn, ;
                                 &( Stuff( ielem, pos_in_ielem + 1, ellen, elemzn ) ) )
                  stseek += c
                  IF dbFieldInfo( 3, FieldPos(elemf) ) != Len( c )
                     l1 := .T.
                  ENDIF
               ENDIF
            ENDIF
            IF !( elemf $ stusl )
               EXIT
            ENDIF
         ENDDO
      ENDIF
   ENDDO
   IF rez
      Ordsetfocus( iord )
   ENDIF

RETURN rez

FUNCTION CreateFlt( oBrw, cSeek, cFilter1, cFilter2 )

LOCAL b1, b2 := &( "{||" + cFilter2 + "}" )
LOCAL aLen, i, oPBar

   // hwg_writelog( Iif(cSeek==Nil,"Nil",cSeek)+" "+Iif(cFilter1==Nil,"Nil",cFilter1)+" "+Iif(cFilter2==Nil,"Nil",cFilter2) )
   IF cFilter1 != Nil .AND. !Empty( cFilter1 )
      b1 := &( "{||" + cFilter1 + "}" )
   ENDIF
   IF oBrw:aArray == Nil
      aLen        := 100
      oBrw:aArray := Array( aLen )
   ELSE
      aLen := Len( oBrw:aArray )
   ENDIF
   i := 0
#ifndef __LINUX__
   oPBar := HProgressBar():NewBox( ",  ",,,,, 20, Eval( oBrw:bRCou, oBrw ) )
#endif
   IF cSeek != Nil .AND. !Empty( cSeek )
      Dbseek( cSeek )
   ELSE
      GO TOP
   ENDIF
   DO WHILE !Eof() .AND. ( b1 == Nil .OR. Eval( b1 ) )
      IF Eval( b2 )
         i ++
         IF i <= aLen
            oBrw:aArray[ i ] := Recno()
         ELSE
            Aadd( oBrw:aArray, Recno() )
            aLen ++
         ENDIF
      ENDIF
#ifndef __LINUX__
      oPBar:Step()
#endif
      SKIP
   ENDDO
#ifndef __LINUX__
   oPBar:Close()
#endif
   oBrw:nRecords := i
   oBrw:nCurrent := 1
   IF i < aLen
      Asize( oBrw:aArray, i )
   ENDIF
   // oBrw:bLineOut  := {|o|(o:alias)->(dbGoTo(Iif(o:nCurrent>0.AND.o:nCurrent<=o:nRecords,o:aArray[o:nCurrent],RecCount()+1)))}
   oBrw:InitBrw( BRW_ARRAY )
   oBrw:bSKip  := { | o, x | ARSKIP( o, x ), FltGoRec( o ) }
   oBrw:bGoTop := { | o | o:nCurrent := 1, FltGoRec( o ) }
   oBrw:bGoBot := { | o | o:nCurrent := o:nRecords, FltGoRec( o ) }
   oBrw:bGoTo  := { | o, n | o:nCurrent := n, FltGoRec( o ) }

RETURN oBrw:nRecords

FUNCTION FltGoRec( o )

   ( o:alias )->( Dbgoto( Iif( o:nCurrent > 0 .AND. o:nCurrent <= o:nRecords, o:aArray[ o:nCurrent ], Reccount() + 1 ) ) )
RETURN Nil

FUNCTION DestroyFlt( oBrw )

   oBrw:nRecords := Reccount()
   oBrw:bLineOut := Nil
   oBrw:InitBrw( BRW_DATABASE )
RETURN Nil
